=== PKGBUILD ===
# Maintainer: Konstantin Podsvirov <konstantin@podsvirov.pro>

_basename=chrono
_realname=project${_basename}
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=9.0.1
pkgrel=1
pkgdesc='High-performance C++ library for multiphysics and multibody dynamics simulations (mingw-w64)'
arch=('any')
mingw_arch=('mingw64' 'ucrt64')
url='https://projectchrono.org/'
msys2_repository_url='https://github.com/projectchrono/chrono'
license=('spdx:BSD-3-Clause')
depends=("${MINGW_PACKAGE_PREFIX}-eigen3"
         "${MINGW_PACKAGE_PREFIX}-irrlicht"
         "${MINGW_PACKAGE_PREFIX}-python")
makedepends=("${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-swig"
             "${MINGW_PACKAGE_PREFIX}-cc")
source=("${msys2_repository_url}/archive/${pkgver}/${_basename}-${pkgver}.tar.gz"
        '0001-chrono-9.0.1-fix-build.patch'
        '0002-chrono-9.0.1-not-install-irrlicht.patch'
        '0003-chrono-9.0.1-fix-python.patch')
sha256sums=('86da726ed3e3bacf682666b21d9c95dc87746b026dbafc722051a3202b822d39'
            '22e6a9521e790eee407551202418d4332068e95022c1bd8c8c5dd3eca2035e78'
            '5c5f70d2c134fc90f52484f36e84464f7e040e483a09cc81a425ff2589377477'
            '2874a51c3cdb3848440e47b37b8d94624a90f59e10a97ae96d3378707aa942cc')

prepare() {
  cd "${_basename}-${pkgver}"

  patch -Np1 -i "${srcdir}"/0001-chrono-9.0.1-fix-build.patch
  patch -Np1 -i "${srcdir}"/0002-chrono-9.0.1-not-install-irrlicht.patch
  patch -Np1 -i "${srcdir}"/0003-chrono-9.0.1-fix-python.patch
}

build() {
  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    cmake \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      "${extra_config[@]}" \
      -DBUILD_{SHARED,STATIC}_LIBS=ON \
      -DENABLE_MODULE_IRRLICHT=ON \
      -DENABLE_MODULE_PYTHON=ON \
      -DIRRLICHT_INSTALL_DIR="${MINGW_PREFIX}" \
      -DBUILD_TESTING=ON \
      -S "${_basename}-${pkgver}" \
      -B "build-${MSYSTEM}"

  cmake --build "build-${MSYSTEM}"
}

check() {
  cmake --build "build-${MSYSTEM}" --target test
}

package() {
  DESTDIR="${pkgdir}" cmake --install "build-${MSYSTEM}"

  install -Dm644 "${srcdir}/${_basename}-${pkgver}/LICENSE" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE"
}
